Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2424 by niro, Tue Jan 7 13:56:51 2014 UTC revision 2948 by niro, Mon Jun 13 15:03:52 2016 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  # ignore the environment  # setup locales
11  LC_ALL=C  TEXTDOMAIN=installer
12    
13  # include dir  # include dir
14  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
15    
# Line 27  for inc in %SYSCONFDIR%/installer.conf \ Line 28  for inc in %SYSCONFDIR%/installer.conf \
28   ${INSTALLER_LIBDIR}/functions/common.sh \   ${INSTALLER_LIBDIR}/functions/common.sh \
29   ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \   ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
30   ${INSTALLER_LIBDIR}/functions/hwdetection.sh \   ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
31     ${INSTALLER_LIBDIR}/functions/bootloader.sh \
32     ${INSTALLER_LIBDIR}/functions/initrd-tools.sh \
33   ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh   ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
34  do  do
35   if [ -e ${inc} ]   if [ -e ${inc} ]
# Line 37  do Line 40  do
40   fi   fi
41  done  done
42    
43  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  # fetch cmdline
44  # -> now in images.conf  for argv in $*
45  CDIMAGENAME=""  do
46  TOTALLINES=""   case $1 in
47  CURRENTLINE=0   --liveroot) shift; cmdliveroot="$1" ;;
48  if [ -e /mnt/cdrom/system/images.conf ]   --imageroot) shift; cmdimageroot="$1" ;;
49  then   --installroot) shift; cmdinstallroot="$1" ;;
50   source /mnt/cdrom/system/images.conf   --filesystem) shift; cmdformatfilesystem="$1" ;;
51   # check if all required variables are set   --help)
52   [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"   echo "$0 options:"
53   [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"   echo " --liveroot [path]     - override default liveroot"
54  else   echo " --imageroot [path]    - override default imageroot"
55   die "/mnt/cdrom/system/images.conf not found"   echo " --installroot [path]  - override default installroot"
56  fi   echo " --filesystem [fstype] - override default filesystem used to format the disk"
57     exit 0 ;;
58     esac
59     shift
60    done
61    
62  ### System/Config Version  ### System/Config Version
63  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
64  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
65    
66    # initialize global variables so they are exportable
67  # some sane defaults  # some sane defaults
68  CDROOT="${DEFAULT_CDROOT}"  INSTALL_METHOD=""
69  INSTALLROOT="${DEFAULT_INSTALLROOT}"  if [[ -n ${cmdliveroot} ]]
70    then
71     LIVEROOT="${cmdliveroot}"
72    else
73     LIVEROOT="${DEFAULT_LIVEROOT}"
74    fi
75    if [[ -n ${cmdimageroot} ]]
76    then
77     IMAGEROOT="${cmdimageroot}"
78    else
79     IMAGEROOT="${DEFAULT_IMAGEROOT}"
80    fi
81    if [[ -n ${cmdinstallroot} ]]
82    then
83     INSTALLROOT="${cmdinstallroot}"
84    else
85     INSTALLROOT="${DEFAULT_INSTALLROOT}"
86    fi
87  KERNELPKG="${DEFAULT_KERNELPKG}"  KERNELPKG="${DEFAULT_KERNELPKG}"
88  KERNELOPTS="${DEFAULT_KERNELOPTS}"  KERNELOPTS="${DEFAULT_KERNELOPTS}"
89  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
# Line 66  GRUB2OPTS="" Line 91  GRUB2OPTS=""
91  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
92  SPECIALDEVICE=""  SPECIALDEVICE=""
93  FORMFACTOR="${DEFAULT_FORMFACTOR}"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
94  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  if [[ -n ${cmdformatfilesystem} ]]
95    then
96     FORMAT_FILESYSTEM="${cmdformatfilesystem}"
97    else
98     FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
99    fi
100    FLASHDISK=0
101    
102  #################################################  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
103  #  DIALOG BOXEN #  # -> now in images.conf
104  #################################################  CDIMAGENAME=""
105    TOTALLINES=""
106    CURRENTLINE=0
107    if [ -e ${IMAGEROOT}/images.conf ]
108    then
109     source ${IMAGEROOT}/images.conf
110     # check if all required variables are set
111     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in ${IMAGEROOT}/images.conf"
112     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in ${IMAGEROOT}/images.conf"
113    else
114     die "${IMAGEROOT}/images.conf not found"
115    fi
116    
117    ### helper scripts ###
118    
119  trap_exit()  trap_exit()
120  {  {
# Line 79  trap_exit() Line 123  trap_exit()
123   is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys   is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
124   is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot   is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
125   is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}   is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
126     [[ -n ${SWAPHDD} ]] && swapoff ${SWAPHDD}
127    
128   echo $"Installation aborted."   echo $"Installation aborted."
129   exit 1   exit 1
130  }  }
131    
132  dialog_die()  install_meter()
 {  
  ERROR="$1"  
  RETVAL="$?"  
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
 {  
  local retval  
   
  yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"  
  retval=$?  
  if [[ ${retval} -eq 1 ]]  
  then  
  clear  
  echo $"The process was aborted."  
  exit 1  
  fi  
 }  
   
 dialog_setup_hdd_info()  
 {  
  local SHDD="${HDD//\/dev\/}"  
   
  messagebox -h $"[ Harddrive partitioning ]" \  
  $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."  
 }  
   
 dialog_setup_hdd_info_auto()  
133  {  {
134   local SHDD="${HDD//\/dev\/}"   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
135     do
136   messagebox -h $"[ Harddrive partitioning ]" \   CURRENTLINE=$(grep -c . /tmp/install.log)
137   $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"   PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))
138     echo ${PERCENT}
139     sleep 1
140     done
141     rm -f /tmp/install.log
142     return 0
143  }  }
144    
145  dialog_setup_system_menu()  mount_rootfs()
146  {  {
  local mode  
147   local retval   local retval
148    
149   mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \   if [[ -n ${SWAPHDD} ]]
  $"1:Automatic setup (recommended)" \  
  ":" \  
  $":\Z1Expert modes:\Zn" \  
  $"2:Common IDE-disk (manual setup)")  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case "${mode}" in  
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "") dialog_setup_system_menu;;  
  esac  
  fi  
 }  
   
 dialog_hardware_detection()  
 {  
  local message  
   
  run_hardware_detection_disks  
   
  message+=$"Harddrives:\n"  
   
  if [[ ! -z ${ALL_DISKS} ]]  
150   then   then
151   for i in ${ALL_DISKS}   swapon ${SWAPHDD} || dialog_die $"Could not enable swap space '${SWAPHDD}'"
  do  
  message+="\Z3${i}\Zn "  
  done  
  message+="\n"  
152   fi   fi
153    
154   if [[ ! -z ${ALL_CDROMS} ]]   if [[ -n ${ROOTHDD} ]]
155   then   then
156   message+="\n"   if is_mounted --location "${INSTALLROOT}"
  message+=$"Optical disk drives:\n"  
  for i in ${ALL_CDROMS}  
  do  
  message+="\Z3${i}\Zn"  
  done  
  message+="\n"  
  fi  
   
  # other devices  
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;  
  rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;  
  maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;  
  *) message+=$"\n \\ZnCommon device detected.\Zn" ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving  mode.\Zn"  
  fi  
   
  messagebox -y 15 -h $"Detected hardware:" "${message}"  
 }  
   
 dialog_setup_hdd_partitions_manual()  
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
  then  
  dialog_no_harddrive_found  
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
157   then   then
158   dialog_setup_hdd_info   echo $"${INSTALLROOT} already mounted" >&2
159   setup_hdd_partitions_manual   else
160     mount -t "${FORMAT_FILESYSTEM_ROOTHDD}" "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
161   fi   fi
162   fi   fi
 }  
163    
164  dialog_setup_hdd_partitions_auto()   [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
 {  
  local i  
  local retval  
165    
166   if [[ -z ${ALL_DISKS} ]]   if [[ -n ${BOOTHDD} ]]
167   then   then
168   dialog_no_harddrive_found   if is_mounted --location "${INSTALLROOT}"/boot
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
169   then   then
170   dialog_setup_hdd_info_auto   echo $"${INSTALLROOT}/boot already mounted" >&2
171   dialog_setup_hdd_create_partitions   else
172   setup_hdd_partitions_auto   mount -t "${FORMAT_FILESYSTEM_BOOTHDD}" "${BOOTHDD}" "${INSTALLROOT}"/boot || dialog_die $"Could not mount bootfs - drive '${BOOTHDD}' -> '${INSTALLROOT}/boot'"
173   fi   fi
174   fi   fi
175  }  }
176    
177  run_hardware_detection_disks()  umount_rootfs()
178  {  {
179   local bootdev   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
180     is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
181    
182   # all disks but exclude ramdisks   if [[ -n ${SWAPHDD} ]]
  export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')  
  # remove the boot device from ALL_DISKS if it was an usbstick  
  if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]  
183   then   then
184   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"   swapoff ${SWAPHDD} || die
  export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")  
185   fi   fi
  export ALL_CDROMS="$(get_hwinfo cdrom)"  
 }  
   
 dialog_setup_hdd_create_partitions()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Disk Partitionen ..." 3 70  
 }  
   
 dialog_setup_hdd_format()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Datei-Systeme ..." 3 70  
 }  
   
 dialog_install_settings()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Speichere System-Einstellungen ..." 3 70  
 }  
   
 dialog_install_system_image()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --gauge "Kopiere System-Image ..." 6 80  
 }  
   
 install_meter()  
 {  
  while [[ ${CURRENTLINE} != ${TOTALLINES} ]]  
  do  
  CURRENTLINE=$(grep -c . /tmp/install.log)  
  PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))  
  echo ${PERCENT}  
  sleep 1  
  done  
  rm -f /tmp/install.log  
  return 0  
186  }  }
187    
188    install_do_reboot()
 dialog_install_bootsector()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Schreibe den Bootsektor ..." 3 70  
 }  
   
 dialog_install_successful()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81  
 }  
   
 dialog_install_failure()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\  
  Fehler bei ${ERROR}, RetVal: ${RETVAL} \  
  " 10 81  
 }  
   
 dialog_main()  
189  {  {
190   local method=0   reboot
  local retval  
   
  while [[ ${method} -le 2 ]]  
  do  
  method=$(dialog \  
  --backtitle "${TITLE}" \  
  --no-cancel \  
  --ok-label "Weiter" \  
  --stdout \  
  --menu "Konfiguration" 14 70 5 \  
  "1" "AutoSta_LX installieren" \  
  "2" "Uebersicht gefundener Laufwerke" \  
  "3" "Beenden und neustarten" \  
  "4" "Beenden und eine Shell starten")  
  retval=$?  
  [[ ${retval} -eq 1 ]] && exit 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case ${method} in  
  "1") dialog_setup_system_menu ;;  
  "2") dialog_hardware_detection ;;  
  "3") install_do_reboot ;;  
  "4") /bin/bash --login -i ;;  
  esac  
  fi  
  done  
191  }  }
192    
 #################################################  
 # Install Komandos #  
 #################################################  
193  run_hardware_detection()  run_hardware_detection()
194  {  {
195   local hwinfo   local hwinfo
   
196   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
197    
198   # check for special devices/clients:   # check for special devices/clients:
# Line 363  run_hardware_detection() Line 205  run_hardware_detection()
205   if [[ $(< ${i}) = 1 ]]   if [[ $(< ${i}) = 1 ]]
206   then   then
207   removable=1   removable=1
208     # we assume that all removable disks are flash disks on a zotac
209     export FLASHDISK=1
210   fi   fi
211   done   done
212     # smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
213    
214   # only add this for grub legacy, grub2 detect these settings on its own   # only add this for grub legacy, grub2 detect these settings on its own
215   export GRUBLEGACYOPTS="rootdelay=8"   export GRUBLEGACYOPTS="rootdelay=8"
# Line 395  run_hardware_detection() Line 240  run_hardware_detection()
240   export GRUBLEGACYOPTS=""   export GRUBLEGACYOPTS=""
241   fi   fi
242    
243     # check for i845 Chipsets and enable KMS and use 915 drm driver later in initrd
244     if [[ ! -z $(echo "${hwinfo}" | grep -i i845) ]]
245     then
246     export SPECIALDEVICE="i845"
247     # unset default video=1024x768 opt or the drm driver breaks
248     export KERNELOPTS="quiet"
249     export GRUBLEGACYOPTS=""
250     # enable full kms support
251     export GRUB2GFXPAYLOAD="keep"
252     fi
253    
254     # check for radeon gfxcards
255     if [[ ! -z $(echo "${hwinfo}" | grep -i radeon) ]]
256     then
257     # enable full kms support
258     export GRUB2GFXPAYLOAD="keep"
259     fi
260    
261     # requires nomsi to prevent massive IRQ error spam
262     # see: http://ubuntuforums.org/showthread.php?t=1234983
263     if [[ ! -z $(echo "${hwinfo}" | grep -i 'P5VD2-X') ]] || [[ ! -z $(echo "${hwinfo}" | grep -i 'VT8237') ]] || [[ ! -z $(echo "${hwinfo}" | grep -i 'VX700') ]]
264     then
265     export SPECIALDEVICE="nomsi"
266     export KERNELOPTS="${KERNELOPTS} pci=nomsi,noaer"
267     fi
268    
269   # check for special devices/clients:   # check for special devices/clients:
270   # check for laptops and activate cpufreq scaling   # check for laptops and activate cpufreq scaling
271   if [[ $(echo "${hwinfo}" | grep 'Formfactor:' | sed 's:.*Formfactor\:\ \"\(.*\)\":\1:') = laptop ]]   if [[ $(echo "${hwinfo}" | grep 'Formfactor:' | sed 's:.*Formfactor\:\ \"\(.*\)\":\1:') = laptop ]]
# Line 404  run_hardware_detection() Line 275  run_hardware_detection()
275   fi   fi
276  }  }
277    
278  hdd_size_below_256mb()  run_hardware_detection_disks()
279  {  {
280   local hdd="$1"   local bootdev
  local size  
  local retval  
  [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"  
281    
282   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   # all disks but exclude ramdisks
283   if [[ ${size} -le 257000000 ]]   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
284     # remove the boot device from ALL_DISKS if it was an usbstick
285     if [[ $(grep '[[:space:]]${LIVEROOT}[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
286   then   then
287   retval="0"   bootdev=$(grep "[[:space:]]${LIVEROOT}[[:space:]]" /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')
288   else   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  retval="1"  
289   fi   fi
290     export ALL_CDROMS="$(get_hwinfo cdrom)"
  return "${retval}"  
291  }  }
292    
293  setup_hdd_partitions_auto()  auto_partition_clear_disk()
294  {  {
295   ROOTHDD="${HDD}1"   if [ -e ${HDD} ]
   
  # run this only if FDISKPARTITIONBELOW256MB is not already 1  
  if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]  
296   then   then
297   if hdd_size_below_256mb ${HDD}   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
298   then   else
299   FDISKPARTIONBELOW256MB=1   echo "clear disk: device ${HDD} does not exist" >&2
  else  
  FDISKPARTIONBELOW256MB=0  
  fi  
300   fi   fi
301    }
302    
303   ## delete disk  auto_partition_command()
304   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die  {
305     if [ -e ${HDD} ]
  if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]  
306   then   then
  ## setup one bootable partition  
  #1. n= new disk  
  #2. p= primary disk  
  #3. 1= first partition  
  #4. 2= default sector start // small disk needs more space for grub2 mbr sector  
  #5. ''= defaul sector end  
  #6. a= bootable flag  
  #7. 1= boot flag for partition 1  
  #8. w= write/quit  
307   fdisk ${HDD} &> /dev/null << EOF   fdisk ${HDD} &> /dev/null << EOF
308  n  $(echo "${PARTITION_OPTS}")
 p  
 1  
 2  
   
 a  
 1  
 w  
309  EOF  EOF
310   else   else
311   ## setup one bootable partition   echo "partition command: device ${HDD} does not exist" >&2
  #1. n= new disk  
  #2. p= primary disk  
  #3. 1= first partition  
  #4. ''= default sector start  
  #5. ''= defaul sector end  
  #6. a= bootable flag  
  #7. 1= boot flag for partition 1  
  #8. w= write/quit  
  fdisk ${HDD} &> /dev/null << EOF  
 n  
 p  
 1  
   
   
 a  
 1  
 w  
 EOF  
312   fi   fi
313  }  }
314    
315  setup_hdd_partitions_manual()  setup_hdd_partitions()
 {  
  ROOTHDD="${HDD}1"  
   
  ## hdds partitionieren manual  
  cfdisk ${HDD} || dialog_die  
 }  
   
 setup_hdd_format()  
 {  
  mke2fs -j -q ${ROOTHDD} || dialog_die  
 }  
   
 install_mount_rootfs()  
 {  
  mount ${ROOTHDD} ${INSTALLROOT} || dialog_die  
  install -d ${INSTALLROOT}/boot || dialog_die  
  cd ${INSTALLROOT} || dialog_die  
 }  
   
 install_system_image()  
 {  
  tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}  
 }  
   
 install_bootsector_chroot()  
316  {  {
317   local my_roothdd   local partition_number
318   local grubconf=${INSTALLROOT}/boot/grub/grub.conf   local partition_type
319   local grub2conf=/boot/grub/grub.cfg   local partition_start_sector
320     local partition_size
321    
322   # check for grub2   # sanity check - should not happen
323   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]   if is_mounted --device "${ROOTHDD}"
324     then
325     echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
326     umount "${ROOTHDD}"
327     fi
328     if [[ -n ${BOOTHDD} ]]
329   then   then
330   # needed by grub-mkconfig on the first run   if is_mounted --device "${BOOTHDD}"
  if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]  
331   then   then
332   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die   echo "partition: device ${BOOTHDD} is already mounted, umount it" >&2
333     umount "${BOOTHDD}"
334   fi   fi
335     fi
336    
337   # set kernelopts   if [[ ${INSTALL_METHOD} = auto ]]
338   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]   then
339     # run this only if FDISKPARTITIONBELOW256MB is not already 1
340     if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
341   then   then
342   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die   if device_minimum_size "${HDD}" 256
343   else   then
344   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die   FDISKPARTIONBELOW256MB=1
345     else
346     FDISKPARTIONBELOW256MB=0
347     fi
348   fi   fi
  echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die  
349    
350   # grub-legacy   ## delete disk
351   else   auto_partition_clear_disk
  ### grubconf schreiben  
  source ${INSTALLROOT}/boot/kernelversion  
352    
353   #for alx only   # setup partition options
354   if [ -e ${INSTALLROOT}/etc/alx_version ]   export PARTITION_OPTS
355    
356     if [[ -n ${BOOTHDD} ]]
357   then   then
358   OLD_ALXVER="${ALXVER}"   # create a boot disk with 50meg size - bootable
359   source ${INSTALLROOT}/etc/alx_version   partition_type="p"
360   KRNVER="ALX-${ALXVER}"   partition_number="1"
361   ALXVER="${OLD_ALXVER}"   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
362     then
363     # 2= default sector start // small disk needs more space for grub2 mbr sector
364     partition_start_sector="2"
365     else
366     # '' use default sector start
367     partition_start_sector=""
368     fi
369     # 50meg size
370     partition_size="+50M"
371    
372     # create a boot disk with 50meg size - bootable
373     # n= new disk
374     # p= primary disk
375     # w= write/quit
376     PARTITION_OPTS="n
377    ${partition_type}
378    ${partition_number}
379    ${partition_start_sector}
380    ${partition_size}
381    w"
382     # create the disk
383     auto_partition_command
384    
385     # mark the disk bootable
386     PARTITION_OPTS="a
387    ${partition_number}
388    w"
389     auto_partition_command
390    
391   fi   fi
392    
393   [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"   if [[ -n ${SWAPHDD} ]]
394   [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"   then
395   [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"   # p= primary disk
396     partition_type="p"
397     if [[ -n ${BOOTHDD} ]]
398     then
399     # boot disk exist, partition 2
400     partition_number="2"
401     else
402     # boot disk does not exist, partition 1
403     partition_number="1"
404     fi
405     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
406     then
407     # fake sector 2 and fdisk finds the next free sector which must be selected with enter
408     partition_start_sector="2
409    "
410     else
411     # '' use default sector start
412     partition_start_sector=""
413     fi
414     partition_start_sector=""
415     # +2G disk size
416     partition_size="+2G"
417    
418     # create a swap disk with 2GB size
419     PARTITION_OPTS="n
420    ${partition_type}
421    ${partition_number}
422    ${partition_start_sector}
423    ${partition_size}
424    w"
425     # create the disk
426     auto_partition_command
427    
428     # mark disk as swap space
429     PARTITION_OPTS="
430    t"
431     if [[ ${partition_number} != 1 ]]
432     then
433     PARTITION_OPTS+="
434    ${partition_number}"
435     fi
436     PARTITION_OPTS+="
437    82
438    w"
439     auto_partition_command
440     fi
441    
442   # uuid support   if [[ -n ${ROOTHDD} ]]
  if is_uuid_supported  
443   then   then
444   my_roothdd="UUID=$(get_uuid ${ROOTHDD})"   # p= primary disk
445   else   partition_type="p"
446   my_roothdd="${ROOTHDD}"   if [[ -z ${BOOTHDD} ]] && [[ -z ${SWAPHDD} ]]
447     then
448     # boot and swap disk does not exist, partition 1
449     partition_number="1"
450     fi
451     if [[ -n ${BOOTHDD} ]] || [[ -n ${SWAPHDD} ]]
452     then
453     # boot or swap disk exist, partition 2
454     partition_number="2"
455     fi
456     if [[ -n ${BOOTHDD} ]] && [[ -n ${SWAPHDD} ]]
457     then
458     # boot and swap disk does exist, partition 3
459     partition_number="3"
460     fi
461     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
462     then
463     if [[ -z ${BOOTHDD} ]]
464     then
465     # 2= default sector start // small disk needs more space for grub2 mbr sector
466     partition_start_sector="2"
467     else
468     # fake sector 2 and fdisk finds the next free sector which must be selected with enter
469     partition_start_sector="2
470    "
471     fi
472     else
473     # '' use default sector start
474     partition_start_sector=""
475     fi
476     # '' default sector end
477     partition_size=""
478    
479     # create system disk with remaining space
480     # w= write/quit
481     PARTITION_OPTS="n
482    ${partition_type}
483    ${partition_number}
484    ${partition_start_sector}
485    ${partition_size}
486    w"
487     # create the disk
488     auto_partition_command
489    
490     # no boot disk? then this is the boot disk
491     if [[ -z ${BOOTHDD} ]]
492     then
493     # mark the disk bootable
494     PARTITION_OPTS="a
495    ${partition_number}
496    w"
497     auto_partition_command
498     fi
499   fi   fi
500     else
501     cfdisk ${HDD} || dialog_die
502     fi
503    }
504    
505   : > ${grubconf} || dialog_die  setup_hdd_format()
506   echo "default 0" >> ${grubconf} || dialog_die  {
507   echo "timeout 3" >> ${grubconf} || dialog_die   install -d /tmp
508   # using current root password   :> /tmp/format.log
  echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die  
509    
510   echo  >> ${grubconf} || dialog_die   if [[ -n ${SWAPHDD} ]]
511   echo "# normal boot" >> ${grubconf} || dialog_die   then
512   echo "title ${KRNVER}" >> ${grubconf} || dialog_die   # sanity check - should not happen
513   echo "root (hd0,0)" >> ${grubconf} || dialog_die   if is_mounted --device "${SWAPHDD}"
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
514   then   then
515   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die   echo "format: device ${SWAPHDD} is already mounted, umount it" >&2
516     umount "${SWAPHDD}"
517   fi   fi
518     mkswap ${SWAPHDD} || die
519     fi
520    
521   echo >> ${grubconf} || dialog_die   if [[ -n ${BOOTHDD} ]]
522   echo "# admin boot" >> ${grubconf} || dialog_die   then
523   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die   # sanity check - should not happen
524   echo "lock"  >> ${grubconf} || dialog_die   if is_mounted --device "${BOOTHDD}"
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
525   then   then
526   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die   echo "format: device ${BOOTHDD} is already mounted, umount it" >&2
527     umount "${BOOTHDD}"
528   fi   fi
529    
530   echo >> ${grubconf} || dialog_die   mkfs."${FORMAT_FILESYSTEM_BOOTHDD}" "${BOOTHDD}" &>> /tmp/format.log || dialog_die
531   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die   fi
532   echo "lock"  >> ${grubconf} || dialog_die  
533   echo "root (hd0,0)" >> ${grubconf} || dialog_die   if [[ -n ${ROOTHDD} ]]
534   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die   then
535   if is_initrd_supported   # sanity check - should not happen
536     if is_mounted --device "${ROOTHDD}"
537   then   then
538   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
539     umount "${ROOTHDD}"
540   fi   fi
541    
542   # bootsector schreiben chrooted schreiben (lfs/magellan)   mkfs."${FORMAT_FILESYSTEM_ROOTHDD}" "${ROOTHDD}" &>> /tmp/format.log || dialog_die
  cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF  
 /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  
 root (hd0,0)  
 setup (hd0)  
 quit  
 EOF  
 exit 0  
 CHROOTEOF  
543   fi   fi
544    }
545    
546   ## enter chroot  install_system_image()
547   mount -t proc proc ${INSTALLROOT}/proc  {
548   mount -t sysfs sysfs ${INSTALLROOT}/sys   pushd ${INSTALLROOT} > /dev/null
549   mount -o bind /dev ${INSTALLROOT}/dev   tar xvjpf ${IMAGEROOT}/${CDIMAGENAME} -C ${INSTALLROOT}
550   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i   popd > /dev/null
551   umount ${INSTALLROOT}/proc  }
  umount ${INSTALLROOT}/sys  
  umount ${INSTALLROOT}/dev  
  rm ${INSTALLROOT}/root/.installrc  
 }  
   
 is_initrd_supported()  
 {  
  # only generate initrds if the cmd exists  
  [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0  
  return 1  
 }  
   
 install_initrd_chroot()  
 {  
  # only generate initrds if the cmd exists  
  is_initrd_supported || return 0  
   
  DISKMODS="sd_mod"  
  OLDPATAMODS="amd74xx piix sis5513 via82cxxx"  
  PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"  
  SATAMODS="sata_via sata_sis sata_nv"  
  DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"  
  OTHERMODS=""  
  case ${SPECIALDEVICE} in  
  zotac_intel) FBMODS=""; DRMMODS="i915" ;;  
  zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;  
  rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards  
  # not working with kms enabled drivers -> segfaults  
  #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer  
  maxdata) FBMODS="" ;;  
  *) FBMODS="uvesafb" ;;  
  esac  
552    
553   if [[ ${FORMFACTOR} = laptop ]]  install_system_settings()
554    {
555     local CONFIG
556    
557     # write fstab
558     CONFIG="${INSTALLROOT}/etc/fstab"
559     clearconfig
560     if [[ -n ${BOOTHDD} ]]
561   then   then
562   OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"   addconfig -e "UUID=$(get_uuid ${BOOTHDD})\t/\t${FORMAT_FILESYSTEM_BOOTHDD}\tnoatime\t1 1"
563   fi   fi
564     if [[ -n ${ROOTHDD} ]]
565     then
566     addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM_ROOTHDD}\tnoatime\t0 0"
567     fi
568     if [[ -n ${SWAPHDD} ]]
569     then
570     addconfig -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0"
571     fi
572     addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
573     addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
574    
575   # install an appropriate uvesafb.conf   # install network config skeleton
576   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die   CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
577   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die   clearconfig
578     addconfig 'ONBOOT="yes"'
579   # install an appropriate viafb.conf   addconfig 'NETWORKING="dhcp"'
580   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die  
581     # intel framebuffer quirk
582     CONFIG="${INSTALLROOT}/etc/splash/splash.conf"
583     if [ -e ${CONFIG} ] && [ -e /proc/fb ]
584     then
585     if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
586     then
587     fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
588     [[ ${fbdev} != 0 ]] && sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${CONFIG} || dialog_die
589     fi
590     fi
591    }
592    
  # install an appropriate i810fb.conf  
  echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die  
593    
594   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF  ### installer dialogs ###
 echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  
 mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  
 exit 0  
 CHROOTEOF  
595    
596   ## enters chroot  dialog_die()
597   mount -t proc proc ${INSTALLROOT}/proc  {
598   mount -t sysfs sysfs ${INSTALLROOT}/sys   ERROR="$1"
599   mount -o bind /dev ${INSTALLROOT}/dev   RETVAL="$?"
600   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i   dialog_install_failure
601   umount ${INSTALLROOT}/proc   exit 1
  umount ${INSTALLROOT}/sys  
  umount ${INSTALLROOT}/dev  
  rm ${INSTALLROOT}/root/.installrc  
602  }  }
603    
604  is_uuid_supported()  dialog_warning()
605  {  {
606   if [[ -x $(type -P busybox.mkinitrd) ]]   local retval
607    
608     yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
609     retval=$?
610     if [[ ${retval} -eq 1 ]]
611   then   then
612   # only detect uuids if supported   clear
613   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   echo $"The process was aborted."
614   then   exit 1
  return 0  
  fi  
615   fi   fi
   
  return 1  
616  }  }
617    
 get_uuid()  
 {  
  local UUID  
  local SEC_TYPE  
  local TYPE  
618    
619   local dev="$1"  ### installer tasks ###
  [[ -z ${dev} ]] && dialog_die "no dev given"  
620    
621   # check if given device is already an UUID  task_setup_system_menu()
622   if [[ ${dev/UUID=/}x != ${dev}x ]]  {
623     local mode
624     local retval
625    
626     mode="$(dialog_setup_system_menu)"
627     retval=$?
628     [[ ${retval} -eq 1 ]] && return 1
629     if [[ ${retval} -eq 0 ]]
630   then   then
631   eval "${dev}"   case "${mode}" in
632   else   "1") run_install auto ;;
633   eval $(busybox.mkinitrd blkid ${dev} | grep "${dev}:" | sed 's/.*:\ //')   "2") run_install normal ;;
634     "") task_setup_system_menu;;
635     esac
636   fi   fi
  echo "${UUID}"  
637  }  }
638    
639  install_system_settings()  task_hardware_detection()
640  {  {
641   # schreibe fstab   local message
642   if is_uuid_supported  
643     run_hardware_detection_disks
644    
645     message+=$"Harddrives:\n"
646    
647     if [[ ! -z ${ALL_DISKS} ]]
648   then   then
649   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   for i in ${ALL_DISKS}
650   else   do
651   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   message+="\Z3${i}\Zn "
652     done
653     message+="\n"
654   fi   fi
  # not needed busybox loads all with swapon -a, even if not mentioned in fstab  
  #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
655    
656   # install network config skeleton   if [[ ! -z ${ALL_CDROMS} ]]
657   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die   then
658     message+="\n"
659     message+=$"Optical disk drives:\n"
660     for i in ${ALL_CDROMS}
661     do
662     message+="\Z3${i}\Zn"
663     done
664     message+="\n"
665     fi
666    
667   # intel framebufer quirk   # other devices
668   if [[ -e /proc/fb ]]   run_hardware_detection
669     case "${SPECIALDEVICE}" in
670     zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
671     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
672     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
673     i845) message+=$"\n\Z2Intel i845 VGA device detected.\Zn" ;;
674     nomsi) message+=$"\n\Z2Mainboard with P5VD2-X/VT8237/VX700 chipset detected.\Zn"
675     message+=$"\n\Z2Disabling Message Signaled Interrupts (MSI) capability of the kernel.\Zn" ;;
676     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
677     esac
678     if [[ ${FORMFACTOR} = laptop ]]
679   then   then
680   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
681   then   fi
682   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   if [[ ${FLASHDISK} = 1 ]]
683   if [[ ${fbdev} != 0 ]]   then
684   then   message+=$"\n\ZnFlash memory detected.\Zn"
685   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die   message+=$"\n\ZnF2FS will be used as default filesystem within the auto installation mode.\Zn"
  fi  
  fi  
686   fi   fi
 }  
687    
688  install_umount_rootfs()   messagebox -y 12 -h $"Detected hardware:" "${message}"
 {  
  cd /  
  umount ${INSTALLROOT}/boot || dialog_die  
  umount ${INSTALLROOT} || dialog_die  
689  }  }
690    
691  install_do_reboot()  task_select_target_hdd()
692  {  {
693   reboot   if [[ -z ${ALL_DISKS} ]]
694     then
695     dialog_no_harddrive_found
696     exit 1
697     else
698     export HDD=$(dialog_select_target_harddrive)
699     fi
700  }  }
701    
702  #################################################  task_setup_hdd_partitions()
 #     Install Ablauf Scripte #  
 #################################################  
   
 run_install_normal()  
703  {  {
704   dialog_hardware_detection   local retval
   
  dialog_setup_hdd_partitions_manual  
  dialog_setup_hdd_format  
  setup_hdd_format > /dev/null  
  install_mount_rootfs  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image  
705    
706   dialog_install_settings   if [[ -z ${HDD} ]]
707   sleep 1   then
708   install_system_settings   dialog_no_harddrive_found
709   install_initrd_chroot   exit 1
710     else
711     dialog_setup_hdd_info
712     setup_hdd_partitions
713     fi
714    }
715    
716   dialog_install_bootsector  task_main()
717   install_bootsector_chroot  {
718     local method=0
719     local retval
720    
721   install_umount_rootfs   while [[ ${method} -le 2 ]]
722   dialog_install_successful   do
723     method=$(dialog_main)
724     retval=$?
725     [[ ${retval} -eq 1 ]] && exit 1
726     if [[ ${retval} -eq 0 ]]
727     then
728     case ${method} in
729     "1") task_setup_system_menu ;;
730     "2") task_hardware_detection ;;
731     "3") install_do_reboot ;;
732     "4") /bin/bash --login -i ;;
733     esac
734     fi
735     done
736  }  }
737    
738  run_install_auto()  run_install()
739  {  {
740   dialog_hardware_detection   local method="$1"
741    
742     task_hardware_detection
743     task_select_target_hdd
744    
745   dialog_setup_hdd_partitions_auto   case "${method}" in
746     auto)
747     if [[ ${FLASHDISK} = 1 ]]
748     then
749     export BOOTHDD="${HDD}1"
750     export SWAPHDD=""
751     export ROOTHDD="${HDD}2"
752     export FORMAT_FILESYSTEM_BOOTHDD="ext2"
753     export FORMAT_FILESYSTEM_ROOTHDD="f2fs"
754     else
755     # ext4 seems not to be compatible again
756     if [[ ${FORMAT_FILESYSTEM} = ext4 ]]
757     then
758     export BOOTHDD="${HDD}1"
759     export SWAPHDD=""
760     export ROOTHDD="${HDD}2"
761     export FORMAT_FILESYSTEM_BOOTHDD="ext2"
762     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
763     else
764     export BOOTHDD=""
765     export SWAPHDD=""
766     export ROOTHDD="${HDD}1"
767     export FORMAT_FILESYSTEM_BOOTHDD=""
768     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
769     fi
770     fi
771     export INSTALL_METHOD="${method}"
772     ;;
773     normal)
774     export BOOTHDD="${HDD}1"
775     export SWAPHDD="${HDD}2"
776     export ROOTHDD="${HDD}3"
777     export FORMAT_FILESYSTEM_BOOTHDD="${FORMAT_FILESYSTEM}"
778     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
779     export INSTALL_METHOD="${method}"
780     ;;
781     single)
782     export BOOTHDD=""
783     export SWAPHDD=""
784     export ROOTHDD="${HDD}1"
785     export FORMAT_FILESYSTEM_BOOTHDD=""
786     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
787     export INSTALL_METHOD="${method}"
788     ;;
789     flash)
790     export BOOTHDD="${HDD}1"
791     export SWAPHDD=""
792     export ROOTHDD="${HDD}2"
793     export FORMAT_FILESYSTEM_BOOTHDD="ext2"
794     export FORMAT_FILESYSTEM_ROOTHDD="f2fs"
795     export INSTALL_METHOD="${method}"
796     ;;
797     *)
798     die "Unknown install method '${method}', aborting."
799     ;;
800     esac
801    
802     task_setup_hdd_partitions
803   dialog_setup_hdd_format   dialog_setup_hdd_format
804   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
805   install_mount_rootfs   mount_rootfs
806   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
807    
808   dialog_install_settings   dialog_install_settings
809   sleep 1   sleep 1
810   install_system_settings   install_system_settings
811   install_initrd_chroot   if is_initrd_supported
812     then
813     dialog_install_initrd
814     initrd_config
815     initrd_install
816     fi
817    
818   dialog_install_bootsector   dialog_install_bootsector
819   install_bootsector_chroot   bootloader_config
820     bootloader_install
821    
822   install_umount_rootfs   umount_rootfs
823   dialog_install_successful   dialog_install_successful
824  }  }
825    
826  # set some proper traps  # set some proper traps
827  trap "trap_exit" SIGINT SIGQUIT  trap "trap_exit" SIGINT SIGQUIT
828    
829  dialog_main  task_main
830    
831  exit 0  exit 0

Legend:
Removed from v.2424  
changed lines
  Added in v.2948